#ifndef _TILECONCENTRATIONEVENT_H_
#define _TILECONCENTRATIONEVENT_H_

class TASTileType;

// TODO : (Michael) Get rid of this... we just need a unique identifier for each
// event... could probabily use random numbers since collisions would be rare
// because of the generally small number of tiles
static int global_hash = 1;

class TileConcentrationEvent {
public:
	TileConcentrationEvent() {
		this->probability = 0.0;
		this->tile = NULL;

		global_hash++;
		m_hash = global_hash;
	}

	TileConcentrationEvent(TASTileType* tile, double concentration) {
		this->tile = tile;
		this->probability = concentration;

		global_hash++;
		m_hash = global_hash;
	}

	double getProbability() const {
		return probability;
	}

	typedef int HashType;
	HashType getHash() const {
		return m_hash;
	}

	const TASTileType* getTile() const {
		return tile;
	}

private:
	int m_hash;
	TASTileType* tile;
	double probability;
};

#endif // _TILECONCENTRATIONEVENT_H_